// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_msgs:msg/VerticalAcceleration.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cam_msgs/msg/vertical_acceleration.hpp"


#ifndef ETSI_ITS_CAM_MSGS__MSG__DETAIL__VERTICAL_ACCELERATION__TRAITS_HPP_
#define ETSI_ITS_CAM_MSGS__MSG__DETAIL__VERTICAL_ACCELERATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_msgs/msg/detail/vertical_acceleration__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'vertical_acceleration_value'
#include "etsi_its_cam_msgs/msg/detail/vertical_acceleration_value__traits.hpp"
// Member 'vertical_acceleration_confidence'
#include "etsi_its_cam_msgs/msg/detail/acceleration_confidence__traits.hpp"

namespace etsi_its_cam_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VerticalAcceleration & msg,
  std::ostream & out)
{
  out << "{";
  // member: vertical_acceleration_value
  {
    out << "vertical_acceleration_value: ";
    to_flow_style_yaml(msg.vertical_acceleration_value, out);
    out << ", ";
  }

  // member: vertical_acceleration_confidence
  {
    out << "vertical_acceleration_confidence: ";
    to_flow_style_yaml(msg.vertical_acceleration_confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VerticalAcceleration & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: vertical_acceleration_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_acceleration_value:\n";
    to_block_style_yaml(msg.vertical_acceleration_value, out, indentation + 2);
  }

  // member: vertical_acceleration_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_acceleration_confidence:\n";
    to_block_style_yaml(msg.vertical_acceleration_confidence, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VerticalAcceleration & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_msgs::msg::VerticalAcceleration & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_msgs::msg::VerticalAcceleration & msg)
{
  return etsi_its_cam_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_msgs::msg::VerticalAcceleration>()
{
  return "etsi_its_cam_msgs::msg::VerticalAcceleration";
}

template<>
inline const char * name<etsi_its_cam_msgs::msg::VerticalAcceleration>()
{
  return "etsi_its_cam_msgs/msg/VerticalAcceleration";
}

template<>
struct has_fixed_size<etsi_its_cam_msgs::msg::VerticalAcceleration>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_msgs::msg::AccelerationConfidence>::value && has_fixed_size<etsi_its_cam_msgs::msg::VerticalAccelerationValue>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_msgs::msg::VerticalAcceleration>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_msgs::msg::AccelerationConfidence>::value && has_bounded_size<etsi_its_cam_msgs::msg::VerticalAccelerationValue>::value> {};

template<>
struct is_message<etsi_its_cam_msgs::msg::VerticalAcceleration>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_MSGS__MSG__DETAIL__VERTICAL_ACCELERATION__TRAITS_HPP_
